#ifndef PARTONDIDTRIBUTIONSGRSV96alt_H
#define PARTONDIDTRIBUTIONSGRSV96alt_H

#include "General.h"
#include "PartonDistributions.h"

namespace SANC
{

  extern "C" void parpolinit_();
  extern "C" void parpol_(double *, double *, double *, double *, double *, double *, double *, double *, double *, double *);

  class PartonDistributionsGRSV96alt : public PDF
  {
  public:
    int pdfID() { return 20002; };

  private:
    double XF, umub, dmdb, ubpdb, spdf, glpdf, a1p, a1n, a1d;
    void _init() { parpolinit_(); }

    double _xfA(int i, double x, double Q2)
    {
      parpol_(&x, &Q2, &umub, &dmdb, &ubpdb, &spdf, &glpdf, &a1p, &a1n, &a1d);
      switch (i)
      {
      case -3:
        XF = spdf;
        break;
      case -2:
        XF = ubpdb;
        break;
      case -1:
        XF = ubpdb;
        break;
      case 1:
        XF = dmdb + ubpdb;
        break;
      case 2:
        XF = umub + ubpdb;
        break;
      case 3:
        XF = spdf;
        break;
      default:
        XF = 0.;
        break;
      }
      return XF;
    }

    double _xfB(int i, double x, double Q2)
    {
      parpol_(&x, &Q2, &umub, &dmdb, &ubpdb, &spdf, &glpdf, &a1p, &a1n, &a1d);
      switch (i)
      {
      case -3:
        XF = spdf;
        break;
      case -2:
        XF = ubpdb;
        break;
      case -1:
        XF = ubpdb;
        break;
      case 1:
        XF = dmdb + ubpdb;
        break;
      case 2:
        XF = umub + ubpdb;
        break;
      case 3:
        XF = spdf;
        break;
      default:
        XF = 0.;
        break;
      }
      return XF;
    }
    double _AlfasQ(double Q) { return 0.; }
    double _Q2min() { return 0.4; }
    double _xmin() { return 1.e-4; }
  };
} // namespace SANC

#endif // PARTONDIDTRIBUTIONSGRSV96alt_H
