************************************************************************
* sanc_cc_v1.40 package.
************************************************************************
* File (cc_ha_1314_1516.f) is created on Tue Aug  9 22:37:43 MSD 2011.
************************************************************************
* This is the FORTRAN module (cc_ha_1314_1516) to calculate differential
* hard photon Bremsstrahlung for the anti-up + dn -> mn + mo^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ha_1314_1516_pol (s,spr,ph3,costh3,costh5,hardpp,hardpm,hardmp,hardmm)
      implicit none!
      include 's2n_declare.h'

      real*8 sq,sqspr,qw
      real*8 hardpp,hardpm,hardmp,hardmm
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph3,cosph3,sinph3,costh3,sinth3,costh5,sinth5
      real*8 sqrtlsupdn,isqrtlsupdn
      real*8 kappaw
      complex*16 chiwspr,chiwsprc,chiws,chiwsc
      real*8 chichicwswspr
      real*8 iz1up,iz2dn,iz4mo,iz3mn,z1,z2,z3,z4
      integer*4 h1,h2,h3,h4,h5,j1,j2,i
      real*8 abs2,abs2p
      real*8 sqs
      real*8 M_I,M_F
      real*8 betai
      complex*16  ampISR(2,2,2,2,2), ampFSR(2,2,2,2,2)
      complex*16  hel_ampISR(2,2,2,2,2), hel_ampFSR(2,2,2,2,2)
      real*8 amp2(2,2,2,2,2),hard2(2,2)
      complex*16 cc1(2,2), cc2(2,2)
      real*8 p1(5), p2(5), p3(5), p4(5), p5(5), q(5)
      real*8 k1(5), k2(5), k3(5), k4(5), k5(5)
      complex*16 SpAA, SpBB
      complex*16 A15A, A25A, A35A, A45A
      complex*16 B51B, B52B, B53B, B54B
      complex*16 A51A, A52A, A53A, A54A, A41A, A21A, A32A, A42A
      complex*16 A12A, A13A, A14A, A23A, A24A, A34A, A43A, A31A
      complex*16 B21B, B31B, B32B,  B41B, B42B, B43B
      complex*16 B12B, B13B, B23B,  B14B, B24B, B34B
      complex*16 B15B, B25B, B35B, B45B
      real*8 Pair
      real*8 q1,q2,q3,q4

! #ifndef GENERATOR
!       real*8 mp(5)

!       mp = (/mel, mel, mmo, mmo, 0d0/)
!       ! toMomenta for cos(theta) & toMomenta1 for rapidity
!       call toMomenta(s,spr,ph3,costh3,costh5,mp)
! #endif

      cmw2 = mw2
      qw = 1d0

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      sinth3 = dsqrt(1d0-costh3**2)
      sinth5 = dsqrt(1d0-costh5**2)

      sqrtlsupdn = sqrt(s**2-2d0*s*(rupm2+rdnm2)+(rupm2-rdnm2)**2)
      isqrtlsupdn = 1d0/sqrtlsupdn

      kappaw = gf*rwm2/(sqrt(2d0)*4d0*pi)/alpha
      if (irun.eq.0) then
         chiwspr = 4d0*kappaw*spr/(spr-cmw2)
      else
         chiwspr = 4d0*kappaw*spr/(spr-dcmplx(mw**2,-spr*ww/mw))
      endif
      chiwsprc = dconjg(chiwspr)

      if (irun.eq.0) then
         chiws = 4d0*kappaw*s/(s-cmw2)
      else
         chiws = 4d0*kappaw*s/(s-dcmplx(mw**2,-s*ww/mw))
      endif
      chiwsc = dconjg(chiws)

      chichicwswspr = chiws*chiwsprc+chiwsc*chiwspr

      p1p2=Pair(pg1,pg2)
      p1p3=Pair(pg1,pg3)
      p1p4=Pair(pg1,pg4)
      p1p5=Pair(pg1,pg5)
      p2p3=Pair(pg2,pg3)
      p2p4=Pair(pg2,pg4)
      p2p5=Pair(pg2,pg5)
      p3p4=Pair(pg3,pg4)
      p3p5=Pair(pg3,pg5)
      p4p5=Pair(pg4,pg5)

      iz1up=
     & +1d0/(mup**2/s+1d0/4*sinth5**2*sqrtlsupdn**2/s**2)/(s-spr)*(1d0/2
     & -1d0/2*mdn**2/s+1d0/2*mup**2/s+1d0/2*costh5*sqrtlsupdn/s)

      iz2dn=
     & +1d0/(mdn**2/s+1d0/4*sinth5**2*sqrtlsupdn**2/s**2)/(s-spr)*(1d0/2
     & +1d0/2*mdn**2/s-1d0/2*mup**2/s-1d0/2*costh5*sqrtlsupdn/s)

      iz4mo=
     & +1d0/(mmo**2/spr+1d0/4*sinth3**2-1d0/2*sinth3**2*mmo**2/spr+1d0/4
     & *sinth3**2*mmo**4/spr**2)/(s-spr)*(1d0/2+1d0/2*mmo**2/spr+1d0/2*c
     & osth3-1d0/2*costh3*mmo**2/spr)

      iz3mn=
     & +1d0/(mmo**2/spr+1d0/4*sinth3**2-1d0/2*sinth3**2*mmo**2/spr+1d0/4
     & *sinth3**2*mmo**4/spr**2)/(s-spr)*(1d0/2-1d0/2*mmo**2/spr-1d0/2*c
     & osth3+1d0/2*costh3*mmo**2/spr)

!-----------------------------------------------------------------------
!--- p(1) = px, p(2) = py, p(3) = pz, p(4) = e, p(5) = m ---------------
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!--- 4-momenta of particles in the laboratory reference frame as input
      p1 = pg1
      p2 = pg2
      p3 = pg3
      p4 = pg4
      p5 = pg5
      ! print *,p1,p2,p3,p4,p5
      ! p3(5)=0d0
      ! p4(5)=0d0
!--- But we work with all momenta to zero setup
!--- Do all momenta incoming
      do i = 1,4
        p3(i) = -p3(i)
        p4(i) = -p4(i)
        p5(i) = -p5(i)
      enddo

      M_I = 0d0
      M_F = mmo
c      M_I = mup
c      M_F = mmo
      ! i3f2 = 1d0
      ! i3f3 = -1d0
      sqs = sqrt(s)
      sqspr = sqrt(spr)
      betai = sqrt((s-(mup-mdn)**2)*(s-(mup+mdn)**2))/s
      betaf = (spr-M_F**2)/spr

      ! call S_CC(p1,p5,-1d0,cc1)
      ! call S_CC(p2,p5,+1d0,cc2)

      ! z1=2d0*Pair(p1,p5)
      ! z2=2d0*Pair(p2,p5)
      ! z3=2d0*Pair(p3,p5)
      ! z4=2d0*Pair(p4,p5)
      z1=(s-spr)*(-(s+mup**2-mdn**2)+costh5*betai*s)/2d0/s
      z2=(s-spr)*(-(s-mup**2+mdn**2)-costh5*betai*s)/2d0/s
      z3=(s-spr)*(mmo**2*(1-costh3)+spr*(1+costh3))/2d0/spr
      z4=(s-spr)*(1-costh3)*(spr-mmo**2)/2d0/spr

      do h1=1,2
         do h2=1,2
           do h3=1,2
             do h4=1,2
               do h5=1,2
                 ampISR(h1,h2,h3,h4,h5)=0d0
                 ampFSR(h1,h2,h3,h4,h5)=0d0
               enddo
             enddo
           enddo
         enddo
      enddo

      q(1)=1d0;
      q(2)=0d0;
      q(3)=0d0;
      q(4)=1d0;
      q(5)=0d0;
      call S_Assoc1(p5, k5);
      call S_Assoc(p1, q, k1);
      call S_Assoc(p2, q, k2);
      call S_Assoc(p3, q, k3);
      call S_Assoc(p4, q, k4);

      A15A = SpAA(k1, k5);
      A25A = SpAA(k2, k5);
      A35A = SpAA(k3, k5);
      A45A = SpAA(k4, k5);
      A12A = SpAA(k1, k2);
      A21A = SpAA(k2, k1);
      A13A = SpAA(k1, k3);
      A31A = SpAA(k3, k1);
      A14A = SpAA(k1, k4);
      A41A = SpAA(k4, k1);
      A23A = SpAA(k2, k3);
      A32A = SpAA(k3, k2);
      A24A = SpAA(k2, k4);
      A42A = SpAA(k4, k2);
      A34A = SpAA(k3, k4);
      A43A = SpAA(k4, k3);
      A51A = SpAA(k5, k1);
      A52A = SpAA(k5, k2);
      A53A = SpAA(k5, k3);
      A54A = SpAA(k5, k4);


      B51B = SpBB(k5, k1);
      B52B = SpBB(k5, k2);
      B53B = SpBB(k5, k3);
      B54B = SpBB(k5, k4);
      B21B = SpBB(k2, k1);
      B31B = SpBB(k3, k1);
      B32B = SpBB(k3, k2);
      B41B = SpBB(k4, k1);
      B42B = SpBB(k4, k2);
      B43B = SpBB(k4, k3);

      B15B = SpBB(k1, k5);
      B25B = SpBB(k2, k5);
      B35B = SpBB(k3, k5);
      B45B = SpBB(k4, k5);
      B12B = SpBB(k1, k2);
      B13B = SpBB(k1, k3);
      B23B = SpBB(k2, k3);
      B14B = SpBB(k1, k4);
      B24B = SpBB(k2, k4);
      B34B = SpBB(k3, k4);

      ! print *,"u:",A15A*B15B,2d0*p1p5,-z1,-2d0*Pair(p1,p5)
      ! print *,"d:",A25A*B25B,2d0*p2p5,-z2,-2d0*Pair(p2,p5)
      ! print *,"mu:",A35A*B35B,-2d0*p3p5,-z3,-2d0*Pair(p3,p5)
      ! print *,"nu:",A45A*B45B,-2d0*p4p5,-z4,-2d0*Pair(p4,p5)
      ! print *,"12:",A12A*B12B,A12A*B21B,-2d0*p1p2,-2d0*Pair(p1,p2)
      ! print *,"34:",A34A*B34B,-2d0*p3p4,-2d0*Pair(p3,p4)
      ! print *,"43:",A43A*B43B,-2d0*p3p4,-2d0*Pair(p3,p4)
      ! print *,"Mnu:",Pair(p3,p3)
      ! print *,"Mmu:",Pair(p4,p4)
      ! print *,"A15A",A15A,conjg(A15A),B15B,B51B
      ! print *,"A25A",A25A,conjg(A25A),B25B,B52B
      ! print *,"A35A",A35A,conjg(A35A),B35B,B53B
      !  print *,"A34A",A34A,conjg(A34A),B34B,B43B
      ! print *,"err=",SpAA(k4, k5),SpAA(p4, k5)

      ! print *,"u:",A15A*B15B,2d0*p1p5,-z1,-2d0*Pair(p1,p5)
      ! print *,"d:",A25A*B25B,2d0*p2p5,-z2,-2d0*Pair(p2,p5)
      ! print *,"mu:",A35A*B35B,-2d0*p3p5,-z3,-2d0*Pair(p3,p5)
      ! print *,"nu_mu:",A45A*B45B,-2d0*p4p5,-z4,-2d0*Pair(p4,p5)

      ! print *,"u:",A15A*B51B,2d0*Pair(p1,p5)
      ! print *,"d:",A25A*B52B,2d0*Pair(p2,p5)
      ! print *,"nu:",A35A*B53B,2d0*Pair(p3,p5)
      ! print *,"mu:",A45A*B54B,2d0*Pair(p4,p5)
      ! print *,"12:",A12A*B21B,2d0*Pair(p1,p2)
      ! print *,"34:",A34A*B43B,2d0*Pair(p3,p4)
      ! print *,"43:",A43A*B34B,2d0*Pair(p3,p4)

      ! ampISR(2,1,2,2,1)=-(B34B*A23A**2/A15A/A25A)*(abs(qup)-p1p5/(p1p5+p2p5))/(spr-cmw2);
      ! ampISR(2,1,2,2,2)=-(A34A*B14B**2/B15B/B25B)*(abs(qup)-p1p5/(p1p5+p2p5))/(spr-cmw2);
      ! ampFSR(2,1,2,2,1)=-(B12B*A23A**2/A35A/A45A)*(abs(qmo)-p4p5/(p3p5+p4p5))/(s-cmw2);
      ! ampFSR(2,1,2,2,2)=-(A12A*B14B**2/B35B/B45B)*(abs(qmo)-p4p5/(p3p5+p4p5))/(s-cmw2);


! VY massless amp
      ! ampISR(2,1,2,2,1)=(B34B*A24A**2/A15A/A25A)*(abs(qup)-p1p5/(p1p5+p2p5))/(spr-cmw2);
      ! ampISR(2,1,2,2,2)=(A43A*B31B**2/B51B/B52B)*(abs(qup)-p1p5/(p1p5+p2p5))/(spr-cmw2);
      ! ampFSR(2,1,2,2,1)=(B21B*A24A**2/A35A/A45A)*(abs(qmo)-p3p5/(p3p5+p4p5))/(s-cmw2);
      ! ampFSR(2,1,2,2,2)=(A12A*B31B**2/B53B/B54B)*(abs(qmo)-p3p5/(p3p5+p4p5))/(s-cmw2);

! Regularized amp
      ! ampISR(2,1,2,2,1)=(B43B*A23A**2*B51B*B52B)*((abs(qup)/z1-abs(qdn)/z2)/(z1+z2))/(spr-cmw2);
      ! ampISR(2,1,2,2,2)=(A34A*B41B**2*A51A*A52A)*((abs(qup)/z1-abs(qdn)/z2)/(z1+z2))/(spr-cmw2);
      ! ampFSR(2,1,2,2,1)=(B21B*A23A**2*B53B*B54B)*(abs(qmo)/z3/(z3+z4))/(s-cmw2);
      ! ampFSR(2,1,2,2,2)=(A12A*B41B**2*A53A*A54A)*(abs(qmo)/z3/(z3+z4))/(s-cmw2);
      ! print *,abs2(-(B12B*A24A**2*B35B*B45B*iz3mn*iz4mo)*(abs(qmo)-iz4mo/(iz4mo+iz3mn))/(s-cmw2))
      ! print *,abs2((B21B*A24A**2/A35A/A45A)*(abs(qmo)-p3p5/(p3p5+p4p5))/(s-cmw2))
      ! print *,abs2(-(B12B*A23A**2/A35A/A45A)*(abs(qmo)-p4p5/(p3p5+p4p5))/(s-cmw2))
      q1=-qup
      q2=qdn
      q3=1d0
      q4=0d0
      ! print *,iz3mn*iz4mo*(abs(qmo)-iz4mo/(iz4mo+iz3mn)),(q3/z3-q4/z4)/(z3+z4)
      ! print *,(iz3mn-iz4mo)/(iz3mn+iz4mo),(abs(qmo)-iz4mo/(iz4mo+iz3mn))

      ampISR(2,1,2,2,1)=(A51A*A52A*A34A*B23B**2)*(q1/z1-q2/z2)/(z1+z2)/(spr-cmw2);
      ampISR(2,1,2,2,2)=(B15B*B25B*B34B*A41A**2)*(q1/z1-q2/z2)/(z1+z2)/(spr-cmw2);
      ampFSR(2,1,2,2,1)=-(A54A*A53A*A12A*B23B**2)*(q3/z3)/(z3+z4)/(s-cmw2);
      ampFSR(2,1,2,2,2)=-(B35B*B45B*B12B*A41A**2)*(q3/z3)/(z3+z4)/(s-cmw2);

      ! print *,  abs2p(ampISR(2,1,2,2,1),ampFSR(2,1,2,2,1)), abs2(ampISR(2,1,2,2,1)+ampFSR(2,1,2,2,1))
      ! print *,"12",p1p2,-Pair(pg1,pg2)
      ! print *,"23",p2p3,-Pair(pg2,pg4)
      ! print *,"35",p3p5,-Pair(pg4,pg5)
      ! print *,"15",p1p5,-Pair(pg1,pg5)
      ! print *,"15",iz1up,0.5d0/Pair(pg1,pg5),0.5d0/Pair(pg2,pg5)
      ! print *,"35",iz3mo,0.5d0/Pair(pg3,pg5),0.5d0/Pair(pg4,pg5)
      ! print *,ampISR(2,1,2,2,1)+ampFSR(2,1,2,2,1)
      ! print *,ampISR(2,1,2,2,2)+ampFSR(2,1,2,2,2)
      ! print *,ampFSR(2,1,2,2,1)
      ! print *,ampFSR(2,1,2,2,2)


! Dittmaier massless amp
      ! ampISR(2,1,2,2,1)=A23A**2*(-qup*B34B/A15A/A25A/(spr-cmw2)+(qmo*B12B/A35A/A45A+(qdn-qup)*B14B/A25A/A35A)/(s-cmw2)+((qup-qdn)*B34B*B15B/A25A)/(spr-cmw2)/(s-cmw2));
      ! ampISR(2,1,2,2,2)=B14B**2*(-qdn*A34A/B15B/B25B/(spr-cmw2)+(qmn*A12A/B35B/B45B+(qdn-qup)*A23A/B15B/B45B)/(s-cmw2)+((qdn-qup)*A34A*A25A/B15B)/(spr-cmw2)/(s-cmw2));
      ! ampFSR(2,1,2,2,1)=A23A**2*(-qup*B43B/A15A/A25A/(spr-cmw2)+(qmo*B21B/A53A/A54A+(qdn-qup)*B41B/A25A/A35A)/(s-cmw2)+((qup-qdn)*B43B*B25B/A25A)/(spr-cmw2)/(s-cmw2));
      ! ampFSR(2,1,2,2,2)=B41B**2*(-qdn*A34A/B51B/B52B/(spr-cmw2)+(qmn*A12A/B35B/B45B+(qdn-qup)*A23A/B51B/B45B)/(s-cmw2)+((qdn-qup)*A34A*A25A/B51B)/(spr-cmw2)/(s-cmw2));
      ! ampFSR(2,1,2,2,1)=0d0;
      ! ampFSR(2,1,2,2,2)=0d0;


      ! print *,"D=",ampISR(2,1,2,2,1)
      ! print *,"D=",ampISR(2,1,2,2,2)
      ! print *,"Dn=",ampFSR(2,1,2,2,1)
      ! print *,"Dn=",ampFSR(2,1,2,2,2)
    !   print *,"cc1= ",cc1
    !   print *,"cc2= ",cc2

    !   do h1=1,2
    !     do h2=1,2
    !       do h3=1,2
    !         do h4=1,2
    !           do h5=1,2
    !             hel_ampISR(h1,h2,h3,h4,h5)=0d0
    !             hel_ampFSR(h1,h2,h3,h4,h5)=0d0
    !             do j1 = 1,2
    !               do j2 = 1,2
    !                 hel_ampISR(h1,h2,h3,h4,h5)=hel_ampISR(h1,h2,h3,h4,h5)
    !  &              +cc1(j1,h1)*cc2(j2,h2)*(ampISR(j1,j2,h3,h4,h5))
    !                 hel_ampFSR(h1,h2,h3,h4,h5)=hel_ampFSR(h1,h2,h3,h4,h5)
    !  &              +cc1(j1,h1)*cc2(j2,h2)*(ampFSR(j1,j2,h3,h4,h5))
    !               enddo
    !             enddo
    !           enddo
    !         enddo
    !       enddo
    !     enddo
    !   enddo

! phase space volume
      volum =  1d0/2048d0/pi**4*(s-spr)/s**2*betaf/betai*conhc

! amplitudes squared
      do h1=1,2
        do h2=1,2
          hard2(h1,h2) = 0d0
          do h3=1,2
            do h4=1,2
              do h5=1,2
                amp2(h1,h2,h3,h4,h5) = abs2p(ampISR(h1,h2,3-h3,3-h4,3-h5),ampFSR(h1,h2,3-h3,3-h4,3-h5))
                hard2(h1,h2) = hard2(h1,h2) + amp2(h1,h2,h3,h4,h5)
              enddo
            enddo
          enddo
        enddo
      enddo
c      if (alr.eq.0) then
c        hard =
c     &      ((1d0+lamep)*(1d0+lamem)*hard2(1,1)
c     &      +(1d0+lamep)*(1d0-lamem)*hard2(1,2)
c     &      +(1d0-lamep)*(1d0+lamem)*hard2(2,1)
c     &      +(1d0-lamep)*(1d0-lamem)*hard2(2,2))/4d0
c      elseif (alr.eq.1) then
c        hard =  hard2(1,2)-hard2(2,1)
c      elseif (alr.eq.2) then
c        hard =  hard2(1,2)+hard2(2,1)
c      elseif (alr.eq.3) then
c        hard = (hard2(1,2)+hard2(2,2)-hard2(1,1)-hard2(2,1))/2d0
c      elseif (alr.eq.4) then
c        hard = (hard2(1,2)+hard2(2,2)+hard2(1,1)+hard2(2,1))/2d0
c      endif

c      hard = hard*volum*e**6*2d0/stw4/3d0
c      hard = hard*cfprime
      hardpp = hard2(1,1)*volum*e**6*2d0/stw4/3d0*cfprime
      hardpm = hard2(1,2)*volum*e**6*2d0/stw4/3d0*cfprime
      hardmp = hard2(2,1)*volum*e**6*2d0/stw4/3d0*cfprime
      hardmm = hard2(2,2)*volum*e**6*2d0/stw4/3d0*cfprime

c      if (hard.ne.hard) then
c        print *,"NAN hard:",s,spr
c        hard = 0d0
c      endif
      return
      end
