************************************************************************
* This is the FORTRAN module (nc_br_1313_1616) to calculate EW Born
* cross section and soft photon Bremsstrahlung
* for the anti-up + up -> mo^+ + mo^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_br_13_13_23_1_pol (qs,ts,us,bornpp,bornpm,bornmp,bornmm,softpp,softpm,softmp,softmm,hard)
      implicit none!
      include 's2n_declare.h'

      integer iborn_
      real*8 bornpp,bornpm,bornmp,bornmm
      real*8 softpp,softpm,softmp,softmm
      real*8 lnlaom,cpl,cmi
      real*8 a0s,v0s,vaz
      real*8 a1z,a2z,v1z,v2z,vas
      real*8 softisr,softfsr,softifi
      real*8 kappaz
      complex*16 chizs,chizsc,chizspr,chizsprc
      real*8 betasmomo,ibetasmomo
      real*8 jintqsmomo

      cmz2 = mz2
      s = -qs
      t = -ts
      u = -us

      iborn  = 1
      call nc_si_13_13_23_1_pol (s,t,u,bornpp,bornpm,bornmp,bornmm)
      born = 0.25*(bornpp+bornpm+bornmp+bornmm)
      if (bornpp.ne.bornpp) print *,'Born pp NAN!!!',s,t,u
      if (bornpm.ne.bornpm) print *,'Born pm NAN!!!',s,t,u
      if (bornmp.ne.bornmp) print *,'Born mp NAN!!!',s,t,u
      if (bornmm.ne.bornmm) print *,'Born mm NAN!!!',s,t,u
      if (iborn.eq.1) return

      softpp = soft*bornpp
      softpm = soft*bornpm
      softmp = soft*bornmp
      softmm = soft*bornmm
      hard = 0d0

      return
      end
